<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVideoRecordingRule ArrayType
 * @subpackage Arrays
 */
class ArrayOfVideoRecordingRule extends AbstractStructArrayBase
{
    /**
     * The VideoRecordingRule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\VideoRecordingRule[]
     */
    public $VideoRecordingRule;
    /**
     * Constructor method for ArrayOfVideoRecordingRule
     * @uses ArrayOfVideoRecordingRule::setVideoRecordingRule()
     * @param \CustomerManagement\StructType\VideoRecordingRule[] $videoRecordingRule
     */
    public function __construct(array $videoRecordingRule = array())
    {
        $this
            ->setVideoRecordingRule($videoRecordingRule);
    }
    /**
     * Get VideoRecordingRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\VideoRecordingRule[]|null
     */
    public function getVideoRecordingRule()
    {
        return isset($this->VideoRecordingRule) ? $this->VideoRecordingRule : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVideoRecordingRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVideoRecordingRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVideoRecordingRuleForArrayConstraintsFromSetVideoRecordingRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVideoRecordingRuleVideoRecordingRuleItem) {
            // validation for constraint: itemType
            if (!$arrayOfVideoRecordingRuleVideoRecordingRuleItem instanceof \CustomerManagement\StructType\VideoRecordingRule) {
                $invalidValues[] = is_object($arrayOfVideoRecordingRuleVideoRecordingRuleItem) ? get_class($arrayOfVideoRecordingRuleVideoRecordingRuleItem) : sprintf('%s(%s)', gettype($arrayOfVideoRecordingRuleVideoRecordingRuleItem), var_export($arrayOfVideoRecordingRuleVideoRecordingRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VideoRecordingRule property can only contain items of type \CustomerManagement\StructType\VideoRecordingRule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VideoRecordingRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\VideoRecordingRule[] $videoRecordingRule
     * @return \CustomerManagement\ArrayType\ArrayOfVideoRecordingRule
     */
    public function setVideoRecordingRule(array $videoRecordingRule = array())
    {
        // validation for constraint: array
        if ('' !== ($videoRecordingRuleArrayErrorMessage = self::validateVideoRecordingRuleForArrayConstraintsFromSetVideoRecordingRule($videoRecordingRule))) {
            throw new \InvalidArgumentException($videoRecordingRuleArrayErrorMessage, __LINE__);
        }
        if (is_null($videoRecordingRule) || (is_array($videoRecordingRule) && empty($videoRecordingRule))) {
            unset($this->VideoRecordingRule);
        } else {
            $this->VideoRecordingRule = $videoRecordingRule;
        }
        return $this;
    }
    /**
     * Add item to VideoRecordingRule value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\VideoRecordingRule $item
     * @return \CustomerManagement\ArrayType\ArrayOfVideoRecordingRule
     */
    public function addToVideoRecordingRule(\CustomerManagement\StructType\VideoRecordingRule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\VideoRecordingRule) {
            throw new \InvalidArgumentException(sprintf('The VideoRecordingRule property can only contain items of type \CustomerManagement\StructType\VideoRecordingRule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VideoRecordingRule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\VideoRecordingRule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\VideoRecordingRule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\VideoRecordingRule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\VideoRecordingRule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\VideoRecordingRule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VideoRecordingRule
     */
    public function getAttributeName()
    {
        return 'VideoRecordingRule';
    }
}
